package com.zswl.cloud.springBtach.server.core.job.standard;

import cn.hutool.json.JSONUtil;
import com.github.microservice.auth.client.content.ResultContent;
import com.zhongshu.payment.client.model.order.v2.CreateOrder2Model;
import com.zhongshu.payment.client.service.v2.OrderService2;
import lombok.Data;
import lombok.extern.log4j.Log4j2;
import org.springframework.batch.core.Job;
import org.springframework.batch.core.Step;
import org.springframework.batch.core.configuration.annotation.JobBuilderFactory;
import org.springframework.batch.core.configuration.annotation.StepBuilderFactory;
import org.springframework.batch.core.launch.support.RunIdIncrementer;
import org.springframework.batch.repeat.RepeatStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;

@Data
@Configuration
@Log4j2
public class StandardOrderJob {

    ThreadLocal<ResultContent> resultContent = new ThreadLocal<>();

    ThreadLocal<CreateOrder2Model> parameter = new ThreadLocal<>();
    @Resource
    private StepBuilderFactory stepBuilderFactory;

    @Resource
    private JobBuilderFactory jobBuilderFactory;

    @Autowired
    OrderService2 orderService2;

    public Step checkFrom() {
        return stepBuilderFactory.get("checkFrom")
                .tasklet((contribution, chunkContext) -> {

                    log.info("这里是最基本的检查");
                    log.info("入参数据：{}", JSONUtil.toJsonStr(getParameter().get()));

                    return RepeatStatus.FINISHED;
                })
                .build();
    }

    public Step platformOrder() {
        return stepBuilderFactory.get("standardPlatformOrder")
                .tasklet((contribution, chunkContext) -> {
                    getResultContent().set(orderService2.creat(getParameter().get()));
                    return RepeatStatus.FINISHED;
                })
                .build();
    }

    @Bean
    public Job standardCreatOrder() {
        return getJobBuilderFactory()
                .get("standardCreatOrder")
                .start(checkFrom())
                .next(platformOrder())
                .incrementer(new RunIdIncrementer())
                .build();
    }

}
